pipeline {
  environment {
    dockerImage = ''
    registry = "dengal_user/ubuntu_nginx"
    registryCredential = 'quay-io-creds-repo-a'
    TAG = "${BUILD_NUMBER}"
  }
  agent any
  stages {
    stage('Cloning Git') {
      steps {
        git([url: 'https://gitlab.com/p.udin.g.rw/goose_publab.git', branch: 'main'])
 
      }
    }
    stage('Building image') {
      steps{
        script {
          docker.build("dengal_user/ubuntu_nginx:${TAG}")
        }
      }
    }
    stage('Deploying container to Kubernetes') {
      steps {
          sh '''#!/bin/bash
                  kubectl apply -f ubuntu_nginx.yaml 
          '''
      }
    }    
    stage('Remove Unused docker image') {
      steps{
        sh "docker rmi -f quay.io/dengal_user/ubuntu_nginx:latest"
        sh "docker rmi -f quay.io/dengal_user/ubuntu_nginx:${TAG}"
        sh "docker rmi -f dengal_user/ubuntu_nginx:${TAG}"
       }
    }
  }
}